#include	"mview.h"
#include	"mdir.h"
#include	<stdlib.h>
#include	<io.h>
#include	<string.h>

typedef struct{
	void	*item[DIRMAX];		/* vf */
	void	*next;				/* BLOCKւ̃|C^ */
} BLOCK;

char *
dirdescend( curdir )
DIRNAME	*curdir;
{
	static char	family[128];
	char	*wptr= family + 127;
	DIRNAME	*tmpdir= curdir;
	
	*wptr= NULL;
	do{
		int	i;
		char	*rptr= tmpdir->name;
		i= strlen( rptr );
		rptr+= i;
		for( ; i; i-- )	*--wptr= *--rptr;
		*--wptr= '\\';
	} while( tmpdir= tmpdir->parent );

	return ++wptr;
}

DIRNAME **
closedir( curdir, pos )
DIRNAME	**curdir;
int	pos;
{
	DIRNAME	**list;
	int	i, j, k, newdirnow;
	char	depth;

	depth= curdir[pos]->depth;
	for( i= pos + 1; i < DirNow; i++ ){
		if( curdir[i]->depth >= depth )	break;
	}
	newdirnow= DirNow - ( i - pos );
	
	list= malloc( ( newdirnow ) * sizeof( DIRNAME* ) );
	if( !list )	return curdir;

	for( j= 0, k= 0; j < pos; ){
		list[j++]= curdir[k++];
	}
	for( k= i; j < DirNow; ){
		list[j++]= curdir[k++];
	}
	free( curdir );
	DirNow= newdirnow;
	return	list;

}

static void
insertdir( listblock, count, parent )
BLOCK	*listblock;
int	count;
DIRNAME	*parent;
{
	int	i, j, k;
	DIRNAME	**list;

	list= malloc( ( count + DirNow ) * sizeof( DIRNAME* ) );
	if( !list ){
		for( i= 0; i < count; i++ ){
			free( listblock->item[i] );
		}
	}
	if( DirList ){
		DirNow+= count;
		for( j= 0, k= 0; j < DirNow; ){
			list[j++]= DirList[k];
			if( DirList[k++] == parent )	break;
		}
		for( i= 0; i < count; i++ ){
			list[j++]= listblock->item[i];
		}
		for( ; j < DirNow; ){
			list[j++]= DirList[k++];
		}
		free( DirList );
	}else {
		for( i= 0; i < count; i++ ){
			list[i]= listblock->item[i];
		}
		DirNow= count;
	}
	DirList= list;
	return;
}

/* ŏ̃fBNgŃfBNgT */
int
DIRGET( targetdir, parent )
char	*targetdir;
DIRNAME	*parent;
{
	BLOCK	*blockhead;
	DIRNAME	*tmpdir;
	char	Temp[256], FileName[256],
			DirNameReal[DIRMAX][24], CheckFlag,
			DirRealOn[DIRMAX];
	int	i, j, DirNowReal, SaveFlag;
	int	newDirNow;
	FILE	*fp;

	DirNowReal= 0;				/* ۂɂfBNg */
	newDirNow= 0;
	SaveFlag= FALSE;			/* DIR.INFۑ邩̃tO */

	blockhead= malloc( sizeof( BLOCK ) );
	if( !blockhead ){
		ConsoleOpen();
		ConsolePrint( "mview : ܂" );
		return FALSE;
	}

	strcpy( Temp, targetdir );
	strcat( Temp, "*.*" );

	{
		char	*FoundFile;
		char	files_buffer[150],		/* files(fBNg)p */
				files_atr;
		int	files_date;
		size_t	files_len;

		FoundFile= files( files_buffer, &files_atr, &files_date,
							&files_len, Temp, 0x10 );
		while( FoundFile ){			/* A */
			if ( strcmp( FoundFile, "." ) && strcmp( FoundFile, ".." ) ){
						/* JgfBNgƐefBNg͊O */
				strcpy( DirNameReal[DirNowReal], FoundFile );
				DirRealOn[DirNowReal++] = 0;
			}
			FoundFile= nfiles( files_buffer, &files_atr, &files_date, &files_len );
		}
	}

	if( !DirNowReal )	return FALSE;

	strcpy( FileName, CDir );
	strcat( FileName, "DIR.INF" );
	if( fp= fopen( FileName, "rt" ) ){
		while( fgets( Temp, 256, fp ) ){
			char	*rptr= Temp;
			Temp[strlen( Temp ) - 1]= NULL;	/* sƂ΂ */
			for( ; *rptr && *rptr != '\t'; rptr++ );
			if( *rptr )	*rptr++= NULL;
			CheckFlag= FALSE;
			for( j= 0; j < DirNowReal; j++ ){	/* DIR.INF̃fBNg邩 */
				if( !strcmpi( Temp, DirNameReal[j] ) ){
					if( !( tmpdir= malloc( sizeof( DIRNAME ) ) ) )	break;
					strcpy( tmpdir->name, Temp );
					strcpy(	tmpdir->optname, rptr );
					blockhead->item[newDirNow++]= tmpdir;
					CheckFlag= TRUE;
					DirRealOn[j]= 1;
					break;
					}
			}
			if( !CheckFlag ){			/* x}b`Ȃ΍폜Ă */
				 SaveFlag= TRUE;
			}
		}
		fclose( fp );
	}

	if( newDirNow ){							/* DIR.INFɏ񂠂 */
		for( i= 0; i < DirNowReal; i++ ){
			if( DirRealOn[i] )	continue;
											/* DIR.INFɒǉ */
			if( !( tmpdir= malloc( sizeof( DIRNAME ) ) ) )	break;
			strcpy( tmpdir->name, DirNameReal[i] );
			tmpdir->optname[0]= NULL;
			blockhead->item[newDirNow++]= tmpdir;
			SaveFlag= TRUE;
		}
	}else {			/* DIR.INFȂ΂̂܂܃Rs[ */
		newDirNow= DirNowReal;
		for( i= 0; i < DirNowReal; i++ ){
			if( !( tmpdir= malloc( sizeof( DIRNAME ) ) ) )	break;
			strcpy( tmpdir->name, DirNameReal[i] );
			tmpdir->optname[0]= NULL;
			blockhead->item[i]= tmpdir;
		}
		SaveFlag= TRUE;
	}
	for( i= 0; i < newDirNow; i++ ){
			tmpdir= blockhead->item[i];
			tmpdir->flag= '+';
			tmpdir->parent= parent;
			tmpdir->depth= (parent)? (parent->depth + 1):0;
			if( !tmpdir->optname[0] ){
				strcpy( tmpdir->optname, tmpdir->name );
			}
	}

	if( SaveFlag ){		/* DIR.INFZ[u */
		if( !(fp= fopen( FileName, "wt" ) ) ){
			ConsoleOpen();
			ConsolePrint( "mview : DIR.INF쐬ł܂\n" );
		}else {
			for( i= 0; i < newDirNow; i++ ){
				tmpdir= blockhead->item[i];
				sprintf( Temp, "%s\t%s\n", tmpdir->name, tmpdir->optname );
				fputs( Temp, fp );
			}
			fclose ( fp );
		}
	}
	if( newDirNow ){
		insertdir( blockhead, newDirNow, parent );
		if( parent )	parent->flag= '-';
	}else {
		if( parent )	parent->flag= ' ';
	}
	free( blockhead );
	return newDirNow;
}
