#include	"mview.h"
#include	"mdir.h"
#include	<HS_wlib.h>
#include	<string.h>

extern int	FormatstringD( char*, DIRNAME* );
extern void	DirChange( WindowID, int );
static void	cursormove( WindowID, int );

#define		Ctrl(a)	((a)&0x1f)
#define		CFN(a)	((a)|0x200)
#define		Esc(a)	((a)|0x100)

static void
cursormove( wp, y )
WindowID	wp;
int	y;
{
	DrawBuf	dbuf[2], *dp= dbuf;
	char	buf[2][40];
	int	attr, i= 2, j;

	attr= AttrDefault;
	while( --i >= 0 ){
		if( DirPos == DirCurPos )	attr^= 8;
		j= FormatstringD( buf[i], DirList[DirCurPos] );
		DrawSetSymbol( dp++, j, DirCurPos * 12, buf[i], attr, 12 );
		attr= AttrDefault | AttrUnderLine;
		DirCurPos= y;
	}
	WindowDraw( wp, dbuf, dp - dbuf );

}


/* L[샋[` */
int
DirKey( wp, info )
WindowID wp;
EventInfo *info;
{
	unsigned int Key= info->KeyCode;
	int	i, y= HS_WindowGetHomeY( wp ) / 12;

	if( Key >= FuncKey && (info->ShiftStat & 2) )
		Key |= 0x200;

	switch( Key ){
	case FuncKeyUp:
	case Ctrl('e'):
	case Ctrl('p'):
		if( DirCurPos ){	/* uv */
			i= DirCurPos - 1;
			cursormove( wp, i );
			if( DirNow > 20 && i < y ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, -12 );
			}
		}
		break;

	case FuncKeyDown:
	case Ctrl('n'):
	case Ctrl('x'):
		i= DirCurPos + 1;
		if ( i < DirNow ) {	/* uv */
			cursormove( wp, i );
			if( DirNow > 20 && i >= y + 20 ){
				/* 炵ĂXN[ */
				WindowScroll( wp, 0, 12 );
			}

		}
		break;

	case FuncKeyRollDown:	/* uROLL DOWNv */
	case Ctrl( 'r' ):
	case Ctrl( 'z' ):
		if( DirCurPos ){
			i= DirCurPos - 19;
			if( i < 0 ){	/* Eяo␳ */
				i= 0;
			}
			cursormove( wp, i );
			if( y && DirNow > 20 ){ /* [? */
				WindowScroll( wp, 0, -12 * 19 );	/* Py[Wړ */
			}
		}
		break;

	case FuncKeyRollUp:		/* uROLL UPv */
	case Ctrl('v'):
	case Ctrl('c'): 
		if( DirCurPos != DirNow - 1 ){
			i= DirCurPos + 19;
			if( i >= DirNow ){	/* Eяo␳ */
				i = DirNow - 1;
			}
			cursormove( wp, i );
			if( DirNow > 20 && y + 20 <= DirNow ){/* I[? */
				WindowScroll( wp, 0, 12 * 19 );	/* Py[Wړ */
			}
		}
		break;

	case FuncKeyRight:
	case Ctrl('d'):
	case Ctrl('f'):
	case Ctrl('i'):
		Dir= 1;

	case Ctrl('m'):			/* uEv */
		if( DirCurPos != DirPos || DirList[DirCurPos]->flag == '+' ){
			DirChange( wp, DirCurPos );
		}else {
			mesprint( "" );
		}
		break;

	case 'w':		/* Vȃ[̍쐬 */
		WriteMail();
		break;

	case 'q':
	case Ctrl('['):
		quitop();
		break;
	}
	return TRUE;
}
