#include	"mview.h"
#include	"mime.h"
#include	<winop.h>
#include	<string.h>

int	WindowHeapSize= 8 * 1024;

extern int	MainExec( WindowID, EventInfo* );	/* EBhEs֐ */

static int GetEnvRc();
static char *GetKeyword( char*, char* );
static void	SmailInit();
static void	AddressInit();

/* ^ꂽ̒ΏەԂ */
char
*GetKeyword( Str, Temp )
char	*Str;
char	*Temp;
{
	char *ret= Str;
	int	len;

	len= strlen( Temp );
	
	if( strncmp( ret, Temp, len ) )	return NULL;	/* s̏ꍇ */

	ret+= len;						/* Ȃ܂̕Q */
	for( ; *ret == ' ' || *ret == '\t'; ret++ );	/* ^uȂǂƂ΂ */

	len= strlen( ret );
	if( ret[len - 1] == '\n' )	ret[len - 1]= NULL;	/* Ō̉sE */

	return ret;
}


/* ǂݏo */
int
GetEnvRc()
{
	char	Temp[256], *TempP;
	FILE	*fp;
	char	MailboxFlag= 0, MviewerFlag= 0, MedFlag= 0;	/* K{ݒtO */

	ConsoleOpen();
	if ( !( TempP= KoWindowGetEnv( "MVIEWRC" ) ) ) {
		ConsolePrint( "mview : ϐMVIEWRCZbgĂ\n" );
		return FALSE;
	}
	strcpy( Temp, TempP );

	if ( !(fp= fopen( Temp, "rt" ) ) ) {
		ConsolePrintf( "mview : t@C%s܂B\n", Temp );
		return FALSE;
	}

	/* t@Cǂœe */
	while( fgets( Temp, 256, fp ) ){
										/* ߂Ƌs͖ */
		if( Temp[0] == '#' || Temp[0] == '\n' ) continue;

		if( TempP = GetKeyword( Temp, "mailbox" ) ){
			strcpy( Env.Mailbox, TempP );
			strcat( Env.Mailbox, "\\" );
			MailboxFlag= 1;
			continue;
			
		}else if( TempP= GetKeyword( Temp, "koview" ) ){
			char	*tmp;
			for( tmp= Env.Mviewer; *TempP > ' '; *tmp++= *TempP++ );
			*tmp= NULL;
			for( ; *TempP && *TempP <= ' '; TempP++ );
			for( tmp= Env.viewopt; *TempP > ' '; *tmp++= *TempP++ );
			*tmp++= ' ';
			*tmp= NULL;
			MviewerFlag= 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "koed" ) ){
			char	*tmp;
			for( tmp= Env.Med; *TempP > ' '; *tmp++= *TempP++ );
			*tmp= NULL;
			for( ; *TempP && *TempP <= ' '; TempP++ );
			for( tmp= Env.edopt; *TempP > ' '; *tmp++= *TempP++ );
			*tmp++= ' ';
			*tmp= NULL;
			MedFlag= 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "option name" ) ){
			if( !SmailNow ) SmailNow= 1;
			strcpy( Env.SmailName[SmailNow], TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "smail option" ) ){
			if( !SmailNow ) SmailNow= 1;
			strcpy( Env.SmailOption[SmailNow++], TempP );
			continue;	
	
		}else if( TempP= GetKeyword( Temp, "signature name" ) ){
			if( !SignatureNow ) SignatureNow= 1;
			strcpy( Env.SignatureName[SignatureNow], TempP );
			continue;
			
		}else if( TempP= GetKeyword( Temp, "signature file" ) ){
			if( !SignatureNow ) SignatureNow= 1;
			strcpy( Env.SignatureFile[SignatureNow++], TempP );
			continue;
			
		}else if( TempP= GetKeyword( Temp, "mimebox" ) ){
			strcpy( Mimebox, TempP );
			strcat( Mimebox, "\\" );
			MimeFlag = 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "wordrap" ) ){
			strcpy( Env.Wordrap, TempP );
			strcat( Env.Wordrap, "\\" );
			continue;

		}else if( TempP= GetKeyword( Temp, "firstseek" ) ){
			if( !strcmpi( TempP, "start" ) )	Env.SeekFlag = 0;
			if( !strcmpi( TempP, "end" ) )	Env.SeekFlag = 1;
			continue;

		}else if( TempP= GetKeyword( Temp, "quotation mark" ) ){
			strcpy( Env.Qmark, TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "default subject" ) ){
			strcpy( Env.DefSubject, TempP );
			continue;

		}else if( TempP= GetKeyword( Temp, "sentbox" ) ){
			strcpy( Env.Sentbox, TempP );
		}
	}
	if( !(MailboxFlag && MviewerFlag && MedFlag ) ){
		ConsolePrint( "mview : t@CɕK{ڂݒ肳Ă܂\n" );
		fclose( fp );
		return FALSE;
	}
	fclose( fp );
	return TRUE;
}

/* smail֌W̏ */
void
SmailInit()
{
	int	i;

	SignatureNow= 0;
	strcpy( Env.SignatureName[0], "gȂ" );
	SmailNow= 0;
	strcpy( Env.SmailName[0], "ʏ푗M" );
	Env.SmailOption[0][0]= NULL;
	for( i= 1; i < 16; i++ ){
		sprintf( Env.SignatureName[i], "%d", i );
		sprintf( Env.SmailName[i], "IvV%d", i );
		Env.SmailOption[i][0]= NULL;
	}
}

/* AhXǂݍ */
void
AddressInit()
{
	char	Temp[256], *TempP;
	FILE	*fp;

	strcpy( Temp, Env.Mailbox );
	strcat( Temp, "ADRESS.TXT" );
	AddressNow= 0;
	if( fp= fopen( Temp, "rt" ) ){
		while( fgets( Temp, 256, fp ) ){
			TempP= strcpy( Address[AddressNow]. name, Temp );/* ܂O擾 */
			TempP= strchr( TempP, '\t' );	/* AhX̓o */
			*TempP++= NULL;
			Address[AddressNow].address= TempP;
			TempP= strchr( TempP, '\n' );	/* sR[h΂ */
			*TempP= NULL;			/* łP擾 */
			if( ++AddressNow > 128 )	break;
		}
		fclose ( fp );
	}
}

void
WindowMain( argc, argv )
int argc;
char *argv[];
{
	int x= 100, y= 120;
	int	pid, pct= -1;
	
	for( pid= 0; pid= PidSearch( "mview.win", pid + 1 ); pct++ );
	if( pct ){
		WindowConnectionClose();
		return;
	}
	/* tO֌W̏ */
	MimeFlag= 0;
	Env.Wordrap[0]= NULL;
	Env.SeekFlag= 0;
	Env.Sentbox[0]= NULL;
	strcpy( Env.Qmark, "> " );
	strcpy( Env.DefSubject, "*NoTitle*" );

	SmailInit();

	if( !GetEnvRc() ){
		WindowConnectionClose();
		return;
	}
	AddressInit();

	Dir= 1;

	AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	WindowTitleOpen( x, y, 512, 256 + 4 + BUTTON_V, NULL, "MVIEW", Push|Icon|Close, MainExec );
}

