#include	"mview.h"
#include	"mdir.h"
#include	"mime.h"
#include	<HS_wlib.h>
#include	<winop.h>
#include	<string.h>

extern void	Formatstring( char*, struct MAILDATA* );

static void	DragMove( WindowID, EventInfo* );
static int	popupmenu( WindowID, EventInfo* );
void	markop( WindowID, int );
int	MailExec( WindowID, EventInfo* );

#include	"Let1.c"
#include	"Let2.c"
#include	"Let3.c"
#include	"Let4.c"
#include	"Let5.c"
#include	"rmtable.c"

Sheet	*shttbl[]= {
	&Let1Pattern,
	&Let2Pattern,
	&Let3Pattern,
	&Let4Pattern,
	&Let5Pattern
};

static char	*menu[]= {
			"@{",
			"ԐM쐬",
			"VK쐬",
			"",
			"",
			"@ړ",
			"@폜",
			"\XV",
			"S}[N"
};
static char	*sendmenu[]= {
			"@{",
			"@ҏW",
			"VK쐬",
			"@Yt",
			"@M",
			"@ړ",
			"@폜",
			"\XV",
			"S}[N"
};

static unsigned int	work= 0;


void
DragMove( wp, info )
WindowID	wp;
EventInfo	*info;
{
	char	MoveTargetDir[STR_MAX];
	WindowID	cwp;
	int	my_y;
	
	MouseSetDefPat_TUKAMI();
	while( !(WindowGetEventInfo(info) && info->LeftOFF) );
	cwp= WindowGetChild( WindowRootID, info );
	MouseSetNormalPat();
	if( cwp == Bwp ){
		info->y-= BUTTON_V;
		cwp= WindowGetChild( Bwp, info );
		if( cwp == Dwp ){
			my_y= info->y / 12;
			if( my_y < DirNow ){
				strcpy( MoveTargetDir, Env.Mailbox );
				strcat( MoveTargetDir, dirdescend( DirList[my_y] ) );
				strcat( MoveTargetDir, "\\" );
				if( strcmp( CDir, MoveTargetDir ) ){
					Move( MoveTargetDir );
					WindowRedraw( wp );
				}
			}
		}
	}
}


void
markop( wp, y )
WindowID	wp;
int	y;
{
	DrawBuf	dbuf[4], *dp= dbuf;
	char	sbuf[2][62];
	int	attr, readmark;

	if( TargetNum != y ){
		attr= (MailOn[TargetNum])? (AttrDefault ^ 8):AttrDefault;
		readmark= Mail[TargetNum].readmark;
		if( SendFlag )	readmark |= 0x80;
		DrawSetPut( dp++, 0, TargetNum * 12, shttbl[rmtable[readmark]] );
		Formatstring( sbuf[0], &(Mail[TargetNum]) );
		DrawSetSymbol( dp++, 12, TargetNum * 12, sbuf[0], attr, 12 );
	}

	attr= AttrDefault|AttrUnderLine;
	if ( MailOn[y] ) {	/* }[N*/
		MarkNum--;
		MailOn[y]= 0;
	} else {			/* }[Nt */
		MarkNum++;
		MailOn[y]= 1;
		attr^= 8;
	}

	readmark= Mail[y].readmark;
	if( SendFlag )	readmark |= 0x80;
	DrawSetPut( dp++, 0, y * 12, shttbl[rmtable[readmark]] );
	Formatstring( sbuf[1], &(Mail[y]) );
	DrawSetSymbol( dp++, 12, y * 12, sbuf[1], attr, 12 );
	WindowDraw( wp, dbuf, dp - dbuf );

	TargetNum= y;
	return;
}

static int
popupmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	num, px, py;
	char	**curmenu;
	
	curmenu= ( SendFlag )? sendmenu:menu;
	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y - HS_WindowGetHomeY( wp );
	num= PopUpMenu( px-1, py, curmenu, sizeof menu/sizeof(char*), 12 );
	switch( num ){
	case 0:		/*{*/
		ReadMail();
		break;
	case 1:		/*ԐM or ҏW*/
		if( SendFlag ){
			EditMail();
		}else {
			ResMail();
		}
		break;
	case 2:		/*VK*/
		WriteMail();
		break;
	case 3:		/*Yt*/
		if( SendFlag )	MimeAdd();
		break;
	case 4:		/*M*/
		if( SendFlag )	transmit();
		break;
	case 5:		/*ړ*/
		moveop();
		break;
	case 6:		/*폜*/
		delop();
		break;
	case 7:		/*XV*/
		infupdate();
		break;
	case 8:		/*S}[N*/
		allmark();
		break;
	default:
		break;
	}
	return TRUE;
}


int
MailExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf	dbuf[22*2+2], *dp= dbuf;
	char	sbuf[22][62];
	
	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EventAttrDefault );
		DrawSetLine( dp++, BUTTON_H + 20, 6, BUTTON_H + 20 + FONT_H * 23 - 1,
						6 + FONT_V - 1, 1, OptionFill );
		DrawSetSymbol( dp++, BUTTON_H + 20, 6, DirList[DirPos]->optname,
						AttrDefault, 12 );
		WindowDraw( Bwp, dbuf, dp - dbuf );
		WindowRedraw( wp );
		return TRUE;

	case EventRedraw:
	{
		int	i, j, attr, readmark;
		i= HS_WindowGetHomeY( wp )/12;
		if( TargetNum < i || TargetNum >= i + 20 )	TargetNum= i;
		if( MailNow < 20 )	DrawSetClear( dp++, 1 );
		if( i )	i-= 1;
		for( j= 0; i < MailNow && j < 22; i++, j++ ){
			attr= (MailOn[i])? (AttrDefault ^ 8):AttrDefault;
			if(i == TargetNum)	attr|= AttrUnderLine;
			readmark= Mail[i].readmark;
			if( SendFlag )	readmark |= 0x80;
			DrawSetPut( dp++, 0, i * 12, shttbl[rmtable[readmark]] );
			Formatstring( sbuf[j], &(Mail[i]) );
			DrawSetSymbol( dp++, 12, i * 12, sbuf[j], attr, 12 );
		}
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;
	}

	case EventClose:
		WindowClose( wp );
		return TRUE;

	case EventMouseSwitch:{
		int	y= info->y / 12;

		DrawSetLine( dbuf, 0, 242 + 4 + BUTTON_V,  511, 254 + BUTTON_V, 1, OptionFill );
		WindowDraw( Bwp, dbuf, 1 );
		if( y < MailNow ){
			if( info->RightON ){
				TargetNum= y;
				WindowRedraw( wp );
				popupmenu( wp, info );
			}else if( info->LeftON ){
				unsigned int	t= IntervalTime();
				if( info->x <= 16 ){
					TargetNum= y;
					WindowRedraw( wp );
					ReadMail();
				}else {
					markop( wp, y );
					if( t - work < 30 ){
						ReadMail();
					}else if( MarkNum ){
						DragMove( wp, info );
					}
				}
				work= t;
				return TRUE;
			}
		}else {
			if( info->RightON )	popupmenu( wp, info );
		}
		return TRUE;
	}
	}
	return FALSE;
}
